#!/usr/bin/ruby

require 'levdon'

# Account is not necessary during for free version.
ACCESS_TOKEN      = ENV['EATER_ACCESS_TOKEN']
TARGET_PATH       = "/Users/johndoe/Desktop/data/test_data"


TESTS = ["/Users/johndoe/Downloads/j/backup/Movies/gen_movie/SAC17.mp4",
  "http://art51.photozou.jp/pub/275/2258275/photo/115456936_org.v1494939738.jpg",
  "http://techslides.com/demos/sample-videos/small.mp4",
  "/Users/johndoe/Desktop/a.png",
  "/Users/johndoe/test.gif",
  "https://dora-neco.com/img/gif/gif0025.gif"]

TESTS.each{|e|
  begin
    puts e
    puts Levdon.predict(ACCESS_TOKEN,e)
  rescue => err
    puts e
    puts err
  end
}
return;
USE_SYNC = true
if(USE_SYNC)
  api = Levdon.new()
  api.option({:CLASS    => [:CLASS_ADULT]})
  state = api.start(ACCESS_TOKEN)
  if(state[:error])
    puts state[:error]
  else
    Levdon.find_image(TARGET_PATH,{:no_check=>true}) {|obj|
      path    = obj[:source_path]
      res     = api.predict({:target => path})
      
      if res[:error]
        puts res[:error]
      else
        result = res[:results]
        score = result[:CLASS_ADULT]
        sscore1 = (( (score * 10000).to_i)/100).to_s.rjust(5, " ")+"%"
        sscore2 = (score * 10000).to_i.to_s.rjust(5, "0")
        puts "Score: "+sscore1 + " : " + path
      
        dst_dirname     = File.dirname(path)
        FileUtils.mv(path,File.join(dst_dirname,"CLASS_ADULT_"+sscore2+"_"+SecureRandom.uuid+"."+path.split(".")[-1]))
      end
      
    }
  end
  api.close()
else
  api = Levdon.new()
  api.option({
    :CLASS    => [:CLASS_ADULT],
    :PARALLEL => 32
  })

  api.async_start(ACCESS_TOKEN) {|state|
    if(state[:error])
      puts state[:error]
    else
      Levdon.find_image(TARGET_PATH,{:no_check=>true}) {|obj|
        path    = obj[:source_path]
        #next if(File.basename(path).index("CLASS_ADULT_") == 0)
        while(api.queue_size() > 32*4)
          api.poll()
          sleep(0.01)
        end
      
        api.async_predict({:target => path}) {|res|
          if res[:error]
            puts res[:error]
          else
            result = res[:results]
            score = result[:CLASS_ADULT]
            sscore1 = (( (score * 10000).to_i)/100).to_s.rjust(5, " ")+"%"
            sscore2 = (score * 10000).to_i.to_s.rjust(5, "0")
            puts "Score: "+sscore1 + " : " + path
          
            dst_dirname     = File.dirname(path)
            FileUtils.mv(path,File.join(dst_dirname,"CLASS_ADULT_"+sscore2+"_"+SecureRandom.uuid+"."+path.split(".")[-1]))
          
          end
        }
      }
    
      while(api.queue_size()!=0)
        api.poll()
        sleep(0.01)
      end
    
    end
  }
  api.close()

end

